unit semilog;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus,Printers, StdCtrls, ComCtrls;

type
  TPapierlog = class(TForm)
    PrintDialog1: TPrintDialog;
    PrinterSetupDialog1: TPrinterSetupDialog;
    MainMenu1: TMainMenu;
    Quitter1: TMenuItem;
    Imprimer1: TMenuItem;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    TrackBar3: TTrackBar;
    TrackBar4: TTrackBar;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    CheckBox1: TCheckBox;
    procedure Quitter1Click(Sender: TObject);
    procedure Imprimer1Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure TrackBar3Change(Sender: TObject);
    procedure TrackBar4Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Papierlog: TPapierlog;
  Feuille:Tcanvas;
  Epais,Moyen,Fin,Nb_Decade:Integer;
implementation

{$R *.DFM}

function strint(a:integer):string;var s:string; begin str(a,s);strint:=s;end;

procedure TPapierlog.Imprimer1Click(Sender: TObject);
  Var nbx,nby:Double;
      Pour,Pour2:Integer;
      Inter:Single;

Function transX(A:Single):word;
Begin
  TransX:=round((A*Nbx)/25.4);
End;

Function transY(A:Single):word;
Begin
  TransY:=round((A*Nby)/25.4);
End;

procedure ligne(x1,y1,x2,y2:Single;epaisseur:Integer);
Begin
  With Feuille do
  begin
    Pen.Width:=Epaisseur;
    MoveTo(transX(X1),transY(Y1));
    LineTo(transX(X2),transY(Y2));
  end;
End;

begin
  If PrintDialog1.execute Then
  Begin
    nbx:=GetDeviceCaps(Printer.Handle,logpixelsX);
    nby:=GetDeviceCaps(Printer.Handle,logpixelsY);
    Feuille:=Printer.canvas;
    With printer Do
    begin
      Printer.Title:='Semi-log';
      BeginDoc;
        Inter:=265/Nb_Decade;
        For Pour:= 0 to Nb_Decade do
        Begin
          Ligne(10,10+Pour*Inter,200,10+Pour*Inter,Epais);
          For pour2:=0 to 9 do
          begin
            Ligne(10,10+Pour*Inter+inter*ln(1+pour2)/2.302585,200,10+Pour*Inter+inter*ln(1+pour2)/2.302585,Moyen);
            If Papierlog.Checkbox1.Checked then  if pour2 <> 9 then
               Ligne(10,10+Pour*Inter+inter*ln(1+pour2+0.5)/2.302585,200,10+Pour*Inter+inter*ln(1+pour2+0.5)/2.302585,Fin);
            feuille.textout(transX(5),transY( -2+10+Pour*Inter+inter*ln(1+pour2)/2.302585),strint((pour2+1) mod 10) );
          end;
        end;
        For pour:=0 to 38 do
        if odd(pour)then
         ligne(10+pour*5,10,10+pour*5,275,Moyen)
                    else
         ligne(10+pour*5,10,10+pour*5,275,Epais);
         feuille.textout(transX(120),transY(278),'NOM :');
         feuille.textout(transX(190),transY(278),'(ADMR)');
         feuille.textout(transX(20),transY(278),'Lyce SAINT-LOUIS');
      EndDoc;
    end;
  end;
end;


procedure TPapierlog.Quitter1Click(Sender: TObject);
begin
   Close;
end;
Procedure Affecte;
Begin
   Fin:=Papierlog.trackbar1.Position;
   Moyen:=Papierlog.trackbar2.Position;
   Epais:=Papierlog.trackbar3.Position;
   Nb_Decade:=Papierlog.trackbar4.Position;
   Papierlog.Label1.Caption:='Fin = '+strint(Papierlog.trackbar1.Position)+' pixels';
   Papierlog.Label2.Caption:='Moyen = '+strint(Papierlog.trackbar2.Position)+' pixels';
   Papierlog.Label3.Caption:='Epais = '+strint(Papierlog.trackbar3.Position)+' pixels';
   Papierlog.Label4.Caption:=strint(Papierlog.trackbar4.Position)+' Dcades';
end;

procedure TPapierlog.TrackBar1Change(Sender: TObject);
begin
   Affecte;
end;
        
procedure TPapierlog.TrackBar2Change(Sender: TObject);
begin
  Affecte;
end;

procedure TPapierlog.TrackBar3Change(Sender: TObject);
begin
   Affecte;
end;

procedure TPapierlog.TrackBar4Change(Sender: TObject);
begin
   Affecte;
end;

procedure TPapierlog.FormCreate(Sender: TObject);
begin
   Affecte;
end;

end.
